<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>Plasma.Extender</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>Extender Class Reference</h1>
<code>from PyKDE4.plasma import *</code>
<p>
Inherits: <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qgraphicswidget.html">QGraphicsWidget</a> &#x2192; <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a><br />

Namespace: Plasma<br />
<h2>Detailed Description</h2>

<p>Extender plasma/extender.h &lt;Plasma/Extender&gt;
</p>
<p>
Extends applets to allow detachable parts
</p>
<p>
An Extender is a widget that visually extends the normal contents of an applet with
additional dynamic widgets called ExtenderItems. These ExtenderItems can be
detached by the user and dropped either on another Extender or on the canvas directly.
</p>
<p>
This widget allows using ExtenderItems in your applet. Extender takes care of the presentation
of a collection of ExtenderItems and keeps track of ExtenderItems that originate in it.
</p>
<p>
The default Extender implementation displays extender items in a vertical layout with
spacers that appear when dropping an ExtenderItem over it.
</p>
<p>
If you wish to have a different presentation of extender items, you can choose to subclass
Extender and reimplement the extenderItem* events and, optionally, the saveState function.
</p>
<p>
To use an Extender in you applet, you'll have to instantiate one. A call to extender() in your
applet will create an extender on your applet if you haven't got one already. Every applet can
contain only one extender. Think of it as a decorator that adds some functionality to applets
that require it. Never instantiate an Extender before init() in your applet. This won't work
correctly since a scene is required when an Extender is instantiated.
</p>
<p>
As soon as an Extender is instantiated, ExtenderItems contained previously in this Extender are
restored using the initExtenderItem function from the applet the items originally came from. For
more information on how this works and how to use ExtenderItems in general, see the ExtenderItem
API documentation.
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="#obj192923212">Appearance</a>&nbsp;</td><td class="memItemRight" valign="bottom">{&nbsp;NoBorders, BottomUpStacked, TopDownStacked&nbsp;}</td></tr>
<tr><td colspan="2"><br><h2>Signals</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj187331628">geometryChanged</a> ()</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200403308">itemAttached</a> (<a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj181735628">itemDetached</a> (<a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> a0)</td></tr>
<tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192922188">__init__</a> (self, <a href="../plasma/Plasma.Applet.html">Plasma.Applet</a> applet)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Plasma.Extender.Appearance&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj180622764">appearance</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[Plasma::ExtenderIte]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192922540">attachedItems</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[Plasma::ExtenderIte]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192924620">detachedItems</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192923724">emptyExtenderMessage</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Plasma.FrameSvg.EnabledBorders&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj177232236">enabledBordersForItem</a> (self, <a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> item)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj187331628">geometryChanged</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj180624172">item</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> name)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj180621356">itemAddedEvent</a> (self, <a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> item, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpointf.html">QPointF</a> pos)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200403308">itemAttached</a> (self, <a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qvariant.html">QVariant</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj175634380">itemChange</a> (self, QGraphicsItem.GraphicsItemChange change, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qvariant.html">QVariant</a> value)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj181735628">itemDetached</a> (self, <a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj177230444">itemHoverEnterEvent</a> (self, <a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> item)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj177232940">itemHoverLeaveEvent</a> (self, <a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> item)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj177232396">itemHoverMoveEvent</a> (self, <a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> item, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpointf.html">QPointF</a> pos)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj180622092">itemRemovedEvent</a> (self, <a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> item)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[Plasma::ExtenderIte]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192925068">items</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200404460">mousePressEvent</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qgraphicsscenemouseevent.html">QGraphicsSceneMouseEvent</a> event)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200403404">resizeEvent</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qgraphicssceneresizeevent.html">QGraphicsSceneResizeEvent</a> event)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj175635500">saveState</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj180623596">setAppearance</a> (self, Plasma.Extender.Appearance appearance)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192923596">setEmptyExtenderMessage</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> message)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj192922188"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.Applet.html">Plasma.Applet</a>&nbsp;</td>
<td class="paramname"><em>applet</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Creates an extender. Note that extender expects applet to have a config(), and needs a
scene because of that. So you should only instantiate an extender in init() or later, not
in an applet's constructor.
The constructor also takes care of restoring ExtenderItems that were contained in this
extender before, so ExtenderItems are persistent between sessions.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>applet</em>&nbsp;</td><td> The applet this extender is part of. Null is not allowed here.
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj180622764"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Plasma.Extender.Appearance appearance</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> the current way of rendering extender items that is used.
</dd></dl>
</p></div></div><a class="anchor" name="obj192922540"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[Plasma::ExtenderIte] attachedItems</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> a list of all attached extender items.
</dd></dl>
</p></div></div><a class="anchor" name="obj192924620"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[Plasma::ExtenderIte] detachedItems</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> a list of all detached extender items.
</dd></dl>
</p></div></div><a class="anchor" name="obj192923724"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> emptyExtenderMessage</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> The text to be shown whenever the applet's layout is empty.
</dd></dl>
</p></div></div><a class="anchor" name="obj177232236"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Plasma.FrameSvg.EnabledBorders enabledBordersForItem</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a>&nbsp;</td>
<td class="paramname"><em>item</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>This function get's called on every item to determine which background border's to
render.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>item</em>&nbsp;</td><td> the item for which it's position or extender has changed.
</td></tr> </table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> the borders that have to be enabled on it's background.
</dd></dl>
</p></div></div><a class="anchor" name="obj187331628"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> geometryChanged</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Fires when an extender's preferred size changes.
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("geometryChanged()"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj180624172"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a> item</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>name</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>This function can be used for easily determining if a certain item is already displayed
in a extender item somewhere, so your applet doesn't duplicate this item. Say the applet
displays 'jobs', from an engine which add's a source for every job. In sourceAdded you
could do something like:
if (!item(source)) {
//add an extender item monitoring this source.
}
</p></div></div><a class="anchor" name="obj180621356"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> itemAddedEvent</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a>&nbsp;</td>
<td class="paramname"><em>item</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpointf.html">QPointF</a>&nbsp;</td>
<td class="paramname"><em>pos</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Get's called after an item has been added to this extender. The bookkeeping has already
been done when this function get's called. The only thing left to do is put it somewhere
appropriate. The default implementation adds the extenderItem to the appropriate place in
a QGraphicsLinearLayout.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>item</em>&nbsp;</td><td> The item that has just been added.

<tr><td></td><td valign="top"><em>pos</em>&nbsp;</td><td> The location the item has been dropped in local coordinates.
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj200403308"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> itemAttached</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a>&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Fires when an extender item is added to this extender.
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("itemAttached(ExtenderItem*)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj175634380"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qvariant.html">QVariant</a> itemChange</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">QGraphicsItem.GraphicsItemChange&nbsp;</td>
<td class="paramname"><em>change</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qvariant.html">QVariant</a>&nbsp;</td>
<td class="paramname"><em>value</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Reimplemented from QGraphicsWidget
</p></div></div><a class="anchor" name="obj181735628"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> itemDetached</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a>&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Fires when an extender item is removed from this extender.
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("itemDetached(ExtenderItem*)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj177230444"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> itemHoverEnterEvent</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a>&nbsp;</td>
<td class="paramname"><em>item</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Get's called when an ExtenderItem that get's dragged enters this extender. Default
implementation does nothing.
</p></div></div><a class="anchor" name="obj177232940"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> itemHoverLeaveEvent</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a>&nbsp;</td>
<td class="paramname"><em>item</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Get's called when an ExtenderItem that was previously hovering over this extender moves
away from this extender. The default implementation removes any spacer from the layout.
</p></div></div><a class="anchor" name="obj177232396"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> itemHoverMoveEvent</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a>&nbsp;</td>
<td class="paramname"><em>item</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpointf.html">QPointF</a>&nbsp;</td>
<td class="paramname"><em>pos</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Gets called when an ExtenderItem is hovering over this extender. Implement this function
to give some visual feedback about what will happen when the mouse button is released at
that position. The default implementation shows a spacer at the appropriate location in
the layout.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>item</em>&nbsp;</td><td> The item that's hovering over this extender. Most useful for obtaining the
size of the spacer.

<tr><td></td><td valign="top"><em>pos</em>&nbsp;</td><td> The location the item is hovering.
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj180622092"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> itemRemovedEvent</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.ExtenderItem.html">Plasma.ExtenderItem</a>&nbsp;</td>
<td class="paramname"><em>item</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Get's called after an item has been removed from this extender. All bookkeeping has
already been done when this function get's called.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>item</em>&nbsp;</td><td> The item that has just been removed.
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj192925068"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[Plasma::ExtenderIte] items</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> a list of all extender items (attached AND detached) where the source applet is
this applet.
</dd></dl>
</p></div></div><a class="anchor" name="obj200404460"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> mousePressEvent</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qgraphicsscenemouseevent.html">QGraphicsSceneMouseEvent</a>&nbsp;</td>
<td class="paramname"><em>event</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Reimplemented from QGraphicsWidget
</p></div></div><a class="anchor" name="obj200403404"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> resizeEvent</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qgraphicssceneresizeevent.html">QGraphicsSceneResizeEvent</a>&nbsp;</td>
<td class="paramname"><em>event</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Reimplemented from QGraphicsWidget
</p></div></div><a class="anchor" name="obj175635500"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> saveState</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>This function get's called for every extender when plasma exits. Implement this function
to store the current state of this extender (position in a layout for example), so this
can be restored when applet starts again. The default implementation stores the y
coordinate of every extender item in the config field extenderItemPos.
</p></div></div><a class="anchor" name="obj180623596"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setAppearance</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Plasma.Extender.Appearance&nbsp;</td>
<td class="paramname"><em>appearance</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Use this function to instruct the extender on how to render it's items. Usually you will
want to call this function in your applet's constraintsEvent, allthough this is already
done for you when using PopupApplet at base class for your applet. Defaults to NoBorders.
</p></div></div><a class="anchor" name="obj192923596"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setEmptyExtenderMessage</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>message</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p></p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>message</em>&nbsp;</td><td> The text to be shown whenever the applet's extender is empty.
Defaults to i18n'ed "no items".
</td></tr>
</table></dl>
<p>
</p></div></div><hr><h2>Enumeration Documentation</h2><a class="anchor" name="obj192923212"></a>
<div class="memitem">
<div class="memproto">
<table class="memname">
<tr><td class="memname">Appearance</td>
</tr>
</table>
</div>
<div class="memdoc"><p>Description on how to render the extender's items.
</p><dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0"><tr><td valign="top"><em>NoBorders</em>&nbsp;=&nbsp;0</td><td><tr><td valign="top"><em>BottomUpStacked</em>&nbsp;=&nbsp;1</td><td><tr><td valign="top"><em>TopDownStacked</em>&nbsp;=&nbsp;2</td><td></table>
</dl>
</div></div><p>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
